/**************************************************************************//**
 * @file     main.c
 * @version  V1.00
 * $Revision: 1 $
 * $Date: 14/06/12 11:12a $ 
 * @brief    NuEdu Basic01 Volume Knob Sample Code
 *
 * @note
 * Copyright (C) 2014 Nuvoton Technology Corp. All rights reserved.
 ******************************************************************************/
#include <stdio.h>
#include <stdint.h>
#include "NUC230_240.h"

uint32_t ADC_Raw_Data; 

/*---------------------------------------------------------------------------------------------------------*/
/*  MAIN function                                                                                          */
/*---------------------------------------------------------------------------------------------------------*/
int main (void)
{
	 
	  SYS_UnlockReg();
	  /* Enable HIRC clock (Internal RC 22.1184MHz) */
    CLK_EnableXtalRC(CLK_PWRCON_OSC22M_EN_Msk);
    /* Wait for HIRC clock ready */
    CLK_WaitClockReady(CLK_CLKSTATUS_OSC22M_STB_Msk);
    /* Select HCLK clock source as HIRC and and HCLK clock divider as 1 */
    CLK_SetHCLK(CLK_CLKSEL0_HCLK_S_HIRC, CLK_CLKDIV_HCLK(1));
	  SYS_LockReg();
	
    GPIO_SetMode(PD, BIT15, GPIO_PMD_OUTPUT); //LED4
	  
	  //ʼADC	
	  /* Enable ADC module clock */
    CLK_EnableModuleClock(ADC_MODULE);
	  /* ADC clock source is 22.1184MHz, set divider to 7, ADC clock is 22.1184/7 MHz */
    CLK_SetModuleClock(ADC_MODULE, CLK_CLKSEL1_ADC_S_HIRC, CLK_CLKDIV_ADC(7));
    GPIO_DISABLE_DIGITAL_PATH(PA, 0x01);     //رADCͨ
    SYS->GPA_MFP &= ~( SYS_GPA_MFP_PA0_Msk) ; //ADCܽ
    SYS->GPA_MFP |= SYS_GPA_MFP_PA0_ADC0 ;	
		SYS->ALT_MFP1 = 0;
		/* Set the ADC operation mode as single, input mode as single-end and enable the analog input channel 7 */
		ADC_Open(ADC, ADC_ADCR_DIFFEN_SINGLE_END, ADC_ADCR_ADMD_SINGLE, 0x1 << 0);
		/* Power on ADC module */
		ADC_POWER_ON(ADC);

    //ʼPWM 
		SYS->GPA_MFP = SYS_GPA_MFP_PA12_PWM0  ; //PWMܽ
    SYS->ALT_MFP1 = SYS_ALT_MFP1_PA12_PWM0 ; 
    CLK_EnableModuleClock(PWM01_MODULE);	
    /* Select PWM module clock source */
    CLK_SetModuleClock(PWM01_MODULE, CLK_CLKSEL1_PWM01_S_HIRC, 0);	 
	    /* Reset PWMA channel0~channel3 */
    SYS_ResetModule(PWM03_RST);	
	    /* set PWMA channel 0 output configuration */
    PWM_ConfigOutputChannel(PWMA, PWM_CH0, 100, 50);
    /* Enable PWM Output path for PWMA channel 0 */
    PWM_EnableOutput(PWMA, 0x01);
    // Start
    PWM_Start(PWMA, 0x01);
 		
		while(1)	
		{			
				PD->DOUT^=BIT15;   //תIOƽ,LED˸
				ADC_CLR_INT_FLAG(ADC, ADC_ADF_INT); //ADжϱ־
				ADC_START_CONV(ADC); //ADʼת
				while(ADC_GET_INT_FLAG(ADC,ADC_ADF_INT)!=ADC_ADF_INT); //ȴת
				ADC_Raw_Data = ADC_GET_CONVERSION_DATA(ADC,0); //ȡADת
			  //ADֵPWMռձȵLED	
			  PWM_ConfigOutputChannel(PWMA, PWM_CH0,100,(100-(ADC_Raw_Data*100/4096)));
        for(ADC_Raw_Data=0;ADC_Raw_Data<50000;ADC_Raw_Data++);	
		}	
}

